package es.rotxo.escaner;

import android.util.Log;

/**
 * Created by Rotxo on 29/06/2016.
 */
public class EAN8 {


    private String guardaInicio;
    private String guardaFin;
    private String guardaCentro;


    private String Digito1;
    private Digito Digito2;
    private Digito Digito3;
    private Digito Digito4;
    private Digito Digito5;
    private Digito Digito6;
    private Digito Digito7;
    private Digito Digito8;
    private Digito Digito9;

    private String Paridad;
    private String codigo;
    private String codControl;



    private Boolean correcto;

    // PARIDAD   A = IMPAAR B= PAR
    final String tablaParidad []= {"AAAAAA","AABABB","AABBAB","AABBBA","ABAABB","ABBAAB","ABBBAA","ABABAB","ABABBA","ABBABA"};
    final String tablaIzq [][]= {{"0001101","0100111"},{"0011001","0110011"},{"0010011","0011011"},{"0111101","0100001"},{"0100011","0011101"},{"0110001","0111001"},{"0101111","0000101"},{"0111011","0010001"},{"0110111","0001001"},{"0001011","0010111"}};
    final String tablaDer []= {"1110010","1100110","1101100","1000010","1011100","1001110","1010000","1000100","1001000","1110100"};

    public EAN8()
    {
        correcto=false;
    }
    private Digito CodificacionIzq(String binario)
    {
        Digito digito=new Digito(binario);
        for (int i=0;i<=9;i++)
        {
            for (int j=0;j<=1;j++)
            {
               if (tablaIzq[i][j].equals(binario))
                {
                    if (j==0)
                        digito.setParidad("A");
                    else
                        digito.setParidad("B");

                       digito.setNumero(Integer.toString(i));

                }
            }
        }
        return digito;
    }
    private Digito CodificacionDerecha(String binario)
    {
        Digito digito=new Digito(binario);
        for (int i=0;i<=9;i++)
        {

                if (tablaDer[i].equals(digito.getBinario()))
                {

                    digito.setNumero(Integer.toString(i));
                }

        }
        return digito;
    }
    private void CalculaPrimerDigito()
    {
        Paridad=Digito2.getParidad()+Digito3.getParidad()+Digito4.getParidad()+Digito5.getParidad();
        for (int i=0;i<=9;i++)
        {

            if (tablaParidad[i].equals(Paridad))
            {

                Digito1=Integer.toString(i);
                Log.e("EAN8", " PrimerDigito -->"+Digito1);
            }

        }

    }
    public void CalcularNumero()
    {
        codigo=Digito2.getNumero()+Digito3.getNumero()+Digito4.getNumero()+Digito5.getNumero()+Digito6.getNumero()+Digito7.getNumero()+Digito8.getNumero()+Digito9.getNumero();


        DigitoControl();
        if (Digito9.getNumero().equals(codControl)) {
            Log.e("EAN8", " DigitoControl " + codControl + "-->correcto");
            correcto = true;
        }
        else
        {
            correcto = false;
            Log.e("EAN8", " DigitoControl " + codControl + "-->Incorrecto");
        }



    }
    private void DigitoControl(){
        int numero=-1;
        numero=Integer.parseInt(Digito2.getNumero())+Integer.parseInt(Digito4.getNumero())+Integer.parseInt(Digito6.getNumero())+Integer.parseInt(Digito8.getNumero());
        numero*=3;
        numero+=Integer.parseInt(Digito3.getNumero())+Integer.parseInt(Digito5.getNumero())+Integer.parseInt(Digito7.getNumero());
        numero=numero%10;
        if (numero!=0)
            numero=10-numero;

        codControl= Integer.toString(numero);
    }


    //getter y setter


    public void setGuardaInicio(String guardaInicio) {
        this.guardaInicio = guardaInicio;
    }



    public void setGuardaFin(String guardaFin) {
        this.guardaFin = guardaFin;
    }


    public void setGuardaCentro(String guardaCentro) {
        this.guardaCentro = guardaCentro;
    }



    public boolean setDigito2(String binario) {
        Digito2 = CodificacionIzq(binario);

        Log.e("EAN8", " Digito2 "+Digito2.getBinario()+"-->"+Digito2.getNumero());
        return !Digito2.getNumero().equals("NULO");



    }



    public boolean setDigito3(String binario) {
        Digito3 = CodificacionIzq(binario);
        Log.e("EAN8", " Digito3 "+Digito3.getBinario()+"-->"+Digito3.getNumero());
        return !Digito3.getNumero().equals("NULO");
    }



    public boolean setDigito4(String binario) {
        Digito4 = CodificacionIzq(binario);
        Log.e("EAN8", " Digito4 "+Digito4.getBinario()+"-->"+Digito4.getNumero());
        return !Digito4.getNumero().equals("NULO");
    }



    public boolean setDigito5(String binario) {
        Digito5 = CodificacionIzq(binario);
        Log.e("EAN8", " Digito5 "+Digito5.getBinario()+"-->"+Digito5.getNumero());
        CalculaPrimerDigito();
        return !Digito5.getNumero().equals("NULO");
    }



    public boolean setDigito6(String binario) {

        Digito6 = CodificacionDerecha(binario);
        Log.e("EAN8", " Digito6 "+Digito6.getBinario()+"-->"+Digito6.getNumero());
        return !Digito6.getNumero().equals("NULO");
    }



    public boolean setDigito7(String binario) {
        Digito7 = CodificacionDerecha(binario);
        Log.e("EAN8", " Digito7 "+Digito7.getBinario()+"-->"+Digito7.getNumero());


        return !Digito3.getNumero().equals("NULO");

    }



    public boolean setDigito8(String binario) {
        Digito8 = CodificacionDerecha(binario);
        Log.e("EAN8", " Digito8 "+Digito8.getBinario()+"-->"+Digito8.getNumero());
        return !Digito8.getNumero().equals("NULO");
    }

    public boolean setDigito9(String binario) {
        Digito9 = CodificacionDerecha(binario);
        Log.e("EAN8", " Digito9 "+Digito9.getBinario()+"-->"+Digito9.getNumero());
        CalcularNumero();
        return !Digito9.getNumero().equals("NULO");
    }





    public String getCodigo() {
        return codigo;
    }
    public Boolean getCorrecto() {
        return correcto;
    }







}
