package es.rotxo.escaner;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;

/**
 * Created by Rotxo on 04/04/2016.
 */



public class miToast extends Toast {

    private Context context;

    /**
     * constructor que recibe el contexto y la duración del Toast y
     * que se lo pasamos al método setDuracion de la clase de la que hereda
     */

    public miToast(Context cont, int duration ) {
        super(cont);
        context = cont;
        this.setDuration(duration);
    }

    /**
     * método donde inflamos nuestro layout personalizado y le asignamos
     * el texto que recibirá cuando instanciemos el objeto.
     * Además llamamos al método show de la clase de la que hereda para que se muestre por pantalla
     */
    public void show(String codigo) {
        LayoutInflater li = (LayoutInflater) context.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
        View vi = (View) li.inflate(R.layout.custom_layout_toast, null);

        TextView tv = (TextView) vi.findViewById(R.id.barras_toast);
        ImageView img= (ImageView) vi.findViewById(R.id.img_toast);
       this.setView(vi);
        tv.setText(codigo);


        super.show();

    }
}
