package es.rotxo.escaner;

import android.util.Log;

/**
 * Created by Rotxo on 29/06/2016.
 */
public class EAN13 {


    private String guardaInicio;
    private String guardaFin;
    private String guardaCentro;


    private String Digito1;
    private Digito Digito2;
    private Digito Digito3;
    private Digito Digito4;
    private Digito Digito5;
    private Digito Digito6;
    private Digito Digito7;
    private Digito Digito8;
    private Digito Digito9;
    private Digito Digito10;
    private Digito Digito11;
    private Digito Digito12;
    private Digito Digito13;
    private String Paridad;
    private String codigo;
    private String codControl;



    private Boolean correcto;

    // PARIDAD   A = IMPAAR B= PAR
    final String tablaParidad []= {"AAAAAA","AABABB","AABBAB","AABBBA","ABAABB","ABBAAB","ABBBAA","ABABAB","ABABBA","ABBABA"};
    final String tablaIzq [][]= {{"0001101","0100111"},{"0011001","0110011"},{"0010011","0011011"},{"0111101","0100001"},{"0100011","0011101"},{"0110001","0111001"},{"0101111","0000101"},{"0111011","0010001"},{"0110111","0001001"},{"0001011","0010111"}};
    final String tablaDer []= {"1110010","1100110","1101100","1000010","1011100","1001110","1010000","1000100","1001000","1110100"};

    public EAN13()
    {
        correcto=false;
    }
    private Digito CodificacionIzq(String binario)
    {
        Digito digito=new Digito(binario);
        for (int i=0;i<=9;i++)
        {
            for (int j=0;j<=1;j++)
            {
               if (tablaIzq[i][j].equals(binario))
                {
                    if (j==0)
                        digito.setParidad("A");
                    else
                        digito.setParidad("B");

                       digito.setNumero(Integer.toString(i));

                }
            }
        }
        return digito;
    }
    private Digito CodificacionDerecha(String binario)
    {
        Digito digito=new Digito(binario);
        for (int i=0;i<=9;i++)
        {

                if (tablaDer[i].equals(digito.getBinario()))
                {

                    digito.setNumero(Integer.toString(i));
                }

        }
        return digito;
    }
    private void CalculaPrimerDigito()
    {
        Paridad=Digito2.getParidad()+Digito3.getParidad()+Digito4.getParidad()+Digito5.getParidad()+Digito6.getParidad()+Digito7.getParidad();
        for (int i=0;i<=9;i++)
        {

            if (tablaParidad[i].equals(Paridad))
            {

                Digito1=Integer.toString(i);
                Log.e("EAN13", " PrimerDigito -->"+Digito1);
            }

        }

    }
    public void CalcularNumero()
    {
        codigo=Digito1+Digito2.getNumero()+Digito3.getNumero()+Digito4.getNumero()+Digito5.getNumero()+Digito6.getNumero()+Digito7.getNumero()+Digito8.getNumero()+Digito9.getNumero()+Digito10.getNumero()+Digito11.getNumero()+Digito12.getNumero();
        int a=controlCodeCalculator(codigo);
        codControl=Integer.toString(a);
        codigo=codigo+Digito13.getNumero();
        if (codControl.equals(Digito13.getNumero())) {
            Log.e("EAN13", " DigitoControl " + codControl + "-->correcto");
            correcto = true;
        }
        else
        {
            correcto = false;
            Log.e("EAN13", " DigitoControl " + codControl + "-->Incorrecto");
        }



    }
    private int controlCodeCalculator(String firstTwelveDigits)
    {
        char[] charDigits = firstTwelveDigits.toCharArray();
        int[] ean13 =
                {
                        1, 3
                };
        int sum = 0;
        for(int i = 0; i < charDigits.length; i++)
        {
            sum += Character.getNumericValue(charDigits[i]) * ean13[i % 2];
        }
        int checksum = 10 - sum % 10;

        if(checksum == 10)
            checksum = 0;

        return checksum;
    }


    //getter y setter


    public void setGuardaInicio(String guardaInicio) {
        this.guardaInicio = guardaInicio;
    }



    public void setGuardaFin(String guardaFin) {
        this.guardaFin = guardaFin;
    }


    public void setGuardaCentro(String guardaCentro) {
        this.guardaCentro = guardaCentro;
    }



    public boolean setDigito2(String binario) {
        Digito2 = CodificacionIzq(binario);

        Log.e("EAN13", " Digito2 "+Digito2.getBinario()+"-->"+Digito2.getNumero());
        return !Digito2.getNumero().equals("NULO");



    }



    public boolean setDigito3(String binario) {
        Digito3 = CodificacionIzq(binario);
        Log.e("EAN13", " Digito3 "+Digito3.getBinario()+"-->"+Digito3.getNumero());
        return !Digito3.getNumero().equals("NULO");
    }



    public boolean setDigito4(String binario) {
        Digito4 = CodificacionIzq(binario);
        Log.e("EAN13", " Digito4 "+Digito4.getBinario()+"-->"+Digito4.getNumero());
        return !Digito4.getNumero().equals("NULO");
    }



    public boolean setDigito5(String binario) {
        Digito5 = CodificacionIzq(binario);
        Log.e("EAN13", " Digito5 "+Digito5.getBinario()+"-->"+Digito5.getNumero());
        return !Digito5.getNumero().equals("NULO");
    }



    public boolean setDigito6(String binario) {

        Digito6 = CodificacionIzq(binario);
        Log.e("EAN13", " Digito6 "+Digito6.getBinario()+"-->"+Digito6.getNumero());
        return !Digito6.getNumero().equals("NULO");
    }



    public boolean setDigito7(String binario) {
        Digito7 = CodificacionIzq(binario);
        Log.e("EAN13", " Digito7 "+Digito7.getBinario()+"-->"+Digito7.getNumero());
        CalculaPrimerDigito();                              ///revisar

        return !Digito3.getNumero().equals("NULO");

    }



    public boolean setDigito8(String binario) {
        Digito8 = CodificacionDerecha(binario);
        Log.e("EAN13", " Digito8 "+Digito8.getBinario()+"-->"+Digito8.getNumero());
        return !Digito8.getNumero().equals("NULO");
    }



    public boolean setDigito9(String binario) {
        Digito9 = CodificacionDerecha(binario);
        Log.e("EAN13", " Digito9 "+Digito9.getBinario()+"-->"+Digito9.getNumero());
        return !Digito9.getNumero().equals("NULO");
    }


    public boolean setDigito10(String binario) {
        Digito10 = CodificacionDerecha(binario);
        Log.e("EAN13", " Digito10 "+Digito10.getBinario()+"-->"+Digito10.getNumero());
        return !Digito10.getNumero().equals("NULO");

    }



    public boolean setDigito11(String binario) {
        Digito11 =CodificacionDerecha(binario);
        Log.e("EAN13", " Digito11 "+Digito11.getBinario()+"-->"+Digito11.getNumero());
        return !Digito11.getNumero().equals("NULO");
    }



    public boolean setDigito12(String binario) {
        Digito12 = CodificacionDerecha(binario);
        Log.e("EAN13", " Digito12 "+Digito12.getBinario()+"-->"+Digito12.getNumero());
        return !Digito12.getNumero().equals("NULO");
    }



    public boolean setDigito13(String binario) {
        Digito13 = CodificacionDerecha(binario);
        Log.e("EAN13", " Digito7 "+Digito13.getBinario()+"-->"+Digito13.getNumero());
        CalcularNumero();
        return !Digito13.getNumero().equals("NULO");
    }



    public String getCodigo() {
        return codigo;
    }
    public Boolean getCorrecto() {
        return correcto;
    }







}
